/*
 * The RelaxerOrg class library
 *  Copyright (C) 1997-2002  ASAMI, Tomoharu (asami@relaxer.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.relaxer.bus.component;

import java.io.IOException;
import org.relaxer.bus.*;
import org.relaxer.bus.model.*;

/**
 * RBusImporter
 *
 * @since   Jan.  1, 2002
 * @version Jan.  2, 2002
 * @author  ASAMI, Tomoharu (asami@relaxer.org)
 */
public class RBusImporter extends AbstractRBusComponent {
    private String[] args_;

    public void setup(IRBusProperties properties) {
	args_ = properties.getArgs();
    }

    public IRBusSignal stimulas(IRBusSignal signal) {
	try {
	    PlainSignal output = new PlainSignal();
	    for (int i = 0;i < args_.length;i++) {
		output.addValue(new UriValue(args_[i]));
	    }
	    return (output);
	} catch (IOException e) {
	    throw (new RBusException(e));
	}
    }
}
