/*
 * RelaxerOrg class library
 *  Copyright (C) 2000-2002  ASAMI, Tomoharu (asami@relaxer.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.relaxer.goldenport.ports.interpreter;

import org.w3c.dom.*;
import org.relaxer.goldenport.*;

/**
 * CopyOfSubrPattern
 *
 * @since   Jul.  8, 2002
 * @version Sep.  5, 2002
 * @author  ASAMI, Tomoharu (asami@relaxer.org)
 */
public class CopyOfSubrPattern extends SubrPattern {
    public void endElement(
	Element element,
	PortNodeList children,
	PortContext context,
	PortNodeList result
    ) {
//System.out.println("coyp-of");
	Element contextElement = context.peekElement();
//System.out.println(org.relaxer.xml.UXMLMaker.getXMLText(contextElement));
	Document doc = contextElement.getOwnerDocument();
	PortEngine engine = context.getEngine();
	DocumentFragment evaluated = doc.createDocumentFragment();
	NodeList contextChildren = contextElement.getChildNodes();
	int size = contextChildren.getLength();
	for (int i = 0;i < size;i++) {
	    Node child = contextChildren.item(i);
	    if (child instanceof Text) {
		evaluated.appendChild(doc.importNode(child, true));
	    } else if (child instanceof Element) {
		evaluated.appendChild(
		    doc.importNode(
			engine.eval((Element)child, context),
			true
		    )
		);
	    }
	}
	result.addChildren(evaluated);
    }
}
