package org.relaxer.runtime.rFactory;

import java.io.*;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>FDao</b> is generated by Relaxer based on factory.rng.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <element name="dao">
 *   <element name="id">
 *     <data type="token"/>
 *   </element>
 *   <choice>
 *     <element name="jdbc">
 *       <element name="className">
 *         <data type="token"/>
 *       </element>
 *       <element name="uri">
 *         <data type="token"/>
 *       </element>
 *       <element name="table">
 *         <data type="token"/>
 *       </element>
 *       <optional>
 *         <element name="username">
 *           <data type="token"/>
 *         </element>
 *       </optional>
 *       <optional>
 *         <element name="password">
 *           <data type="token"/>
 *         </element>
 *       </optional>
 *       <optional>
 *         <element name="driver">
 *           <data type="token"/>
 *         </element>
 *       </optional>
 *     </element>
 *     <element name="xml">
 *       <element name="className">
 *         <data type="token"/>
 *       </element>
 *       <element name="uri">
 *         <data type="token"/>
 *       </element>
 *     </element>
 *   </choice>
 * </element>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;element name="dao"&gt;
 *   &lt;element name="id"&gt;
 *     &lt;data type="token"/&gt;
 *   &lt;/element&gt;
 *   &lt;choice&gt;
 *     &lt;element name="jdbc"&gt;
 *       &lt;element name="className"&gt;
 *         &lt;data type="token"/&gt;
 *       &lt;/element&gt;
 *       &lt;element name="uri"&gt;
 *         &lt;data type="token"/&gt;
 *       &lt;/element&gt;
 *       &lt;element name="table"&gt;
 *         &lt;data type="token"/&gt;
 *       &lt;/element&gt;
 *       &lt;optional&gt;
 *         &lt;element name="username"&gt;
 *           &lt;data type="token"/&gt;
 *         &lt;/element&gt;
 *       &lt;/optional&gt;
 *       &lt;optional&gt;
 *         &lt;element name="password"&gt;
 *           &lt;data type="token"/&gt;
 *         &lt;/element&gt;
 *       &lt;/optional&gt;
 *       &lt;optional&gt;
 *         &lt;element name="driver"&gt;
 *           &lt;data type="token"/&gt;
 *         &lt;/element&gt;
 *       &lt;/optional&gt;
 *     &lt;/element&gt;
 *     &lt;element name="xml"&gt;
 *       &lt;element name="className"&gt;
 *         &lt;data type="token"/&gt;
 *       &lt;/element&gt;
 *       &lt;element name="uri"&gt;
 *         &lt;data type="token"/&gt;
 *       &lt;/element&gt;
 *     &lt;/element&gt;
 *   &lt;/choice&gt;
 * &lt;/element&gt;
 * </pre>
 *
 * @version factory.rng (Thu Sep 05 12:38:32 JST 2002)
 * @author  Relaxer 0.17b (http://www.relaxer.org)
 */
public class FDao implements java.io.Serializable {
    private String id_;
    private IFDaoChoice content_;

    /**
     * Creates a <code>FDao</code>.
     *
     */
    public FDao() {
    }

    /**
     * Creates a <code>FDao</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public FDao(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>FDao</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public FDao(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>FDao</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public FDao(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>FDao</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public FDao(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>FDao</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public FDao(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>FDao</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public FDao(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>FDao</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public FDao(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>FDao</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public FDao(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>FDao</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public FDao(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>FDao</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>FDao</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>FDao</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        id_ = URelaxer.getElementPropertyAsString(stack.popElement());
        if (FDaoJdbc.isMatch(stack)) {
            setContent(new FDaoJdbc(stack));
        } else if (FDaoXml.isMatch(stack)) {
            setContent(new FDaoXml(stack));
        } else {
            throw (new IllegalArgumentException());
        }
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("dao");
        int size;
        URelaxer.setElementPropertyByString(element, "id", this.id_);
        this.content_.makeElement(element);
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>FDao</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>FDao</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>FDao</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>FDao</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>FDao</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>FDao</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the String property <b>id</b>.
     *
     * @return String
     */
    public final String getId() {
        return (id_);
    }

    /**
     * Sets the String property <b>id</b>.
     *
     * @param id
     */
    public final void setId(String id) {
        this.id_ = id;
    }

    /**
     * Gets the IFDaoChoice property <b>content</b>.
     *
     * @return IFDaoChoice
     */
    public final IFDaoChoice getContent() {
        return (content_);
    }

    /**
     * Sets the IFDaoChoice property <b>content</b>.
     *
     * @param content
     */
    public final void setContent(IFDaoChoice content) {
        this.content_ = content;
    }

    /**
     * Makes a XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        buffer.append("<dao");
        buffer.append(">");
        buffer.append("<id>");
        buffer.append(URelaxer.escapeCharData(URelaxer.getString(getId())));
        buffer.append("</id>");
        content_.makeTextElement(buffer);
        buffer.append("</dao>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        buffer.print("<dao");
        buffer.print(">");
        buffer.print("<id>");
        buffer.print(URelaxer.escapeCharData(URelaxer.getString(getId())));
        buffer.print("</id>");
        content_.makeTextElement(buffer);
        buffer.print("</dao>");
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getIdAsString() {
        return (URelaxer.getString(getId()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setIdByString(String string) {
        setId(string);
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>FDao</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer.isTargetElement(element, "dao")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!URelaxer.isTargetElement(child, "id")) {
            return (false);
        }
        $match$ = true;
        if (FDaoJdbc.isMatchHungry(target)) {
            $match$ = true;
        } else if (FDaoXml.isMatchHungry(target)) {
            $match$ = true;
        } else {
            return (false);
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>FDao</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>FDao</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
