/*
 * RelaxerOrg class library
 *  Copyright (C) 2000-2002  ASAMI, Tomoharu (asami@relaxer.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.relaxer.taglib;

import java.util.*;
import java.io.IOException;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import org.relaxer.util.UException;

/**
 * ServletRequestRedirectTag
 *
 * @since   Apr. 25, 2002
 * @version Apr. 25, 2002
 * @author  ASAMI, Tomoharu (asami@relaxer.org)
 */
public class ServletRequestRedirectTag extends AbstractRelaxerTag {
    private String requestName_ = "relaxer-redirect";

    public final void setRequestName(String name) {
	requestName_ = name;
    }

    public int doStartTag() throws JspTagException {
	_log(".doStartTag");
	HttpServletRequest req = (HttpServletRequest)pageContext.getRequest();
	String target = req.getParameter(requestName_);
	if (target != null) {
	    try {
		HttpServletResponse res
		    = (HttpServletResponse)pageContext.getResponse();
		res.sendRedirect(target);
	    } catch (IOException e) {
		throw (UException.makeJspTagException(e));
	    }
	}
	return (SKIP_BODY);
    }
}
